function alq=calcalmures(al0,be,x,y,dx,dy,mu0,res0,resk)
%
%   
% S. Ulbrich, June 2002
%
% This code comes with no guarantee or warranty of any kind.
%
%
%  computes the maximal 0<=alq<=argmin_{0<=al<=al0} mu(al) such that
%
%  (1-al)*resk<=(be*res0/mu0)*mu(al)
%
%
%
% compute argmin_{0<=al<=al0} mu(al)
n=size(x,1);
b=(y'*dx+x'*dy)/n;
a=(dx'*dy)/n;
c=(x'*y)/n;
al=1;
if (a>0)
 al=-b/(2*a);
end
al=min(al0,al);
alq=al;
%
% ensure (1-al)*resk<=(be*res0/mu0)*mu(al)
%
ka=be*res0/mu0;
if (1-al)*resk>ka*(a*al^2+b*al+c)
 c=ka*c-resk;
 b=resk+ka*b;
 a=ka*a;
 if (abs(a)<=1e-20)&(b<0) %then c>0
  al1=-c/b;
 elsif (a>1e-20)&(b<0)  %then c>0
  al1=(-2*c)/(b-sqrt(b^2-4*a*c));
 elsif (a<-1e-20)&(b<0)
  al1=(-2*c)/(b-sqrt(b^2-4*a*c));
 elsif (a<-1e-20)&(b>=0)
  al1=(-b-sqrt(b^2-4*a*c))/(2*a);
 else
  al1=1;
 end
 alq=min(al,al1);
end
